Se repérer
==========

Bravo, vous affichez le contenu du fichier 'README.md' ! Vous avez
normalement utilisé les commandes suivantes :

-   `cd` pour changer de dossier, et
-   `head` pour afficher le début d'un fichier.

Maintenant, utilisez `cat README.md` pour l'afficher en entier.

Noms de fichiers et adresses
----------------------------

Ces commandes prennent en argument un nom de fichier ou de dossier.  Ce
que l'on entend par ça, c'est plus précisément une *adresse* dans
l'arborescence qui répertorie tous les fichiers de l'ordinateur.

Tout fichier ou dossier possède une *adresse absolue* unique. Par
exemple, l'adresse du dossier dans lequel on se trouve peut être obtenue
avec la commande `pwd`. Testez cette commande, vous devriez voir quelque
chose comme `/home/etudiant/tp/1.1 Se repérer`. Cela signifie que l'on
se place ainsi dans l'arborescence:

    /
    └─ home/
        ├─ etudiant/
        ┆   ├─ tp/
            ┆   ├─ "1.1 Se repérer/"  ← c'est là qu'on est
                │   ├─ README.md      ← c'est ce qu'on lit
                │   ┆
                ├─ "1.2 .../"
                ┆

On peut désigner un nom de fichier par son adresse absolue, c'est-à-dire
que depuis n'importe où sur l'ordinateur, vous pouvez lire ce fichier en
utilisant la commande :

    cat "/home/etudiant/tp/1.1 Se repérer/README.md"

Mais l'on peut aussi vouloir utiliser une *adresse relative*, comme vous
avez déjà fait :

    cat README.md

C'est la plus simple forme d'addresse relative puisque elle désigne un
fichier qui est dans le dossier où l'on se trouve. On peut aussi aller
chercher un fichier ailleurs :

    cat "../1.2 Manipuler/README.md"

Plusieurs remarques à faire ici :

-   On utilise des guillemets "..." quand une adresse comporte des
    espaces (car les espaces séparent différents arguments : la commande
    `cat "un fichier"` demande l'affichage du fichier nommé "un
    fichier", mais la commande `cat un fichier` demande l'affichage du
    fichier "un", puis du fichier "fichier"...)
-   On distingue une adresse relative d'une adresse absolue par le fait
    que la seconde commence par le slash `/` qui désigne la racine de
    l'ordinateur.
-   Le dossier `..` désigne le dossier parent. On peut remonter
    plusieurs dossiers parents : `../../un_fichier`.

Un exercice
-----------

On va utiliser la commande `nano` qui ouvre un éditeur de texte. Cette
commande permet de modifier des fichiers directement dans la console,
elle peut donc prendre en argument le nom d'un fichier.

Utilisez `nano (...)` en remplaçant (...) par une adresse relative pour
modifier le fichier `un_fichier.txt` qui se trouve dans le sous-dossier
`exo` du dossier `1.1 Se repérer`, puis suivez les instructions écrites
dans le fichier.

